<script>
import { get_currency, get_decimal } from '../../../Helper/helper';
import { orderService } from '../../../services';
import OrderShow from './order-show';
import OrderAction from './order-action';
import OrderAssign from './order-assign';
import OrderTrack from './order-track';
import DunzoOrderTrack from './dunzo-order-tracking.vue';
import config from '../../../config';
// import { deliveryZoneService} from '../../../services';

export default {
  components:{ OrderShow, OrderAction,OrderAssign,OrderTrack, DunzoOrderTrack },
  props:{
      'orders':{
        default: {},
        type: Object
      },
      'loading':{
        default: false,
        type: Boolean
      },
      'extra-columns':{
        default: function() {
          return [];
        },
        type: Array
      },
      'status':{
        default: '',
        type: String
      },
  },
  data() {
    return {
      config: config,
      filters: {
        order_status: this.order_status
      },
      meta: [
        { charset: 'utf-8' },
        { equiv: 'Content-Type', content: 'text/html' },
        { name: 'viewport', content: 'width=device-width, initial-scale=1' }
      ],
      decimal: get_decimal(),
      currency: get_currency(),
      fields:[
        { key: "order_id", label: this.trans.get("__JSON__.Order ID"), sortable: false },
        { key: "vendor_name", label: this.trans.get("__JSON__.Vendor's Name",{vendor:this.$auth.getRestaurantName()}), sortable: false },
        { key: "customer_name", label: this.trans.get("__JSON__.Customer Name"), sortable: false },
        { key: "created_date", label: this.trans.get("__JSON__.Time"), sortable: false },
        { key: "total_amount", label: this.trans.get("__JSON__.Amount"), sortable: false },
        // { key: "delivery_pickup_types", label: this.trans.get("__JSON__.Type"), sortable: false },
        { key: "payment_method", label: this.trans.get("__JSON__.Payment"), sortable: false },
        ...(this.extraColumns || []),
        { key: "action", label: this.trans.get("__JSON__.Action"), sortable: false },
      ],
      showModal: false,
      showTrackModel: false,
      order: null,
      viewIndex: 0,
      orderId: null,
      abandonedstatus: '',
      driverServicesList :[],
      showDunzoTrackModel: false
    };
  },
  computed: {
    computedFields() {
      // If the user isn't an admin, filter out fields that require auth.
      if(this.$auth.partner_login)
        return this.fields.filter(field => !field.requiresAdmin);

      // If the user IS an admin, return all fields.
      else
        return this.fields;
    }
  },
  mounted(){
    this.$data.fields[1].label = this.$auth.setting && this.$auth.setting.restaurant_name;
    if(this.extraColumns,this.extraColumns.filter(function(o){return o['key'] === 'assign';}).length > 0){
      this.getDriverServicesList();
    }
  },
  methods: {
    viewDetails(id){
      this.showModal = true;
      this.orderId = id;
      // orderService.getOrder(id)
      //   .then(res => {
      //     this.order = res.data.result;
      //     this.orderLoading = false;
      //   })
    },
    viewPageDetails(item,index, event){
      this.viewIndex = index;
      this.viewDetails(item.base_id);
      this.$refs.selectableTable.clearSelected()
    },
    abandonedStatusChange() {
      this.$emit("abandonedstatusEmitchanged", this.abandonedstatus);
    },
    trackOrder(order){
      this.showTrackModel = true;
      this.order = order;
    },
    trackDunzoOrder(order) {
      this.showDunzoTrackModel = true;
      this.order = order;
    },
    checkDunzoTrackAvailability(order) {
      if (order && order.is_dunzo_driver == '1') {
        if (order.dunzo_driver) {
          if (order.dunzo_driver.tracking_url != '' && order.dunzo_driver.tracking_url != null) {
            return true;
          }
        }
      }
      return false;
    },
    getDriverServicesList(){
      this.driverServicesList = [];
      deliveryZoneService.getZoneDeliveryService().then(response => {
        if(response.data.code == 200){
          this.driverServicesList = response.data.result;
        }
      });
    }
  },
};
</script>
<template>

<div class="row ">
  <div class="col-12 m-order-main">
    <!-- <span v-if="status == 'PaymentFailure'" class="text-warning" ><strong>Pending :</strong></span><span v-if="status == 'PaymentFailure'"  class="text-warning"> Customer did not proceed with Payment.</span><br  v-if="status == 'PaymentFailure'" />
    <span v-if="status == 'PaymentFailure'" class="text-danger" ><strong>Failed :</strong></span><span v-if="status == 'PaymentFailure'"  class="text-danger"> Customer tried to pay but failed due to issue with Card/Bank/Wallet.</span> -->
    <div class="row align-items-center mb-2" v-if="status == 'PaymentFailure'">
      <div class="col-10">
        <span class="text-warning"><strong>{{ trans.get('__JSON__.Pending') }} : </strong></span>
        <span class="text-warning">{{ trans.get('__JSON__.Customer did not proceed with Payment.') }}</span><br>
        <span class="text-danger"><strong>{{ trans.get('__JSON__.Failed') }} : </strong></span>
        <span class="text-danger">{{ trans.get('__JSON__.Customer tried to pay but failed due to issue with Card/Bank/Wallet.') }}</span><br>
        <span class="text-info"><strong>{{ trans.get('__JSON__.Awaiting') }} : </strong></span>
        <span class="text-info">{{ trans.get('__JSON__.Awaiting') }}</span>
      </div>
      <div class="col-2">
        <label>{{ trans.get('__JSON__.Status') }} :</label>
        <select class="custom-select" v-model="abandonedstatus" @change="abandonedStatusChange">
          <option value="" selected>{{ trans.get('__JSON__.All') }}</option>
          <option value="PaymentPending">{{ trans.get('__JSON__.Pending') }}</option>
          <option value="PaymentFailure">{{ trans.get('__JSON__.Failed') }}</option>
          <option value="AwaitForPayment">{{ trans.get('__JSON__.Awaiting') }}</option>
        </select>
      </div>
    </div>
    <div class="order-table-data table-responsive order-data-table table-border-0 scroll-table">
    <b-table
      :items="orders && orders.data || []"
      :fields="computedFields"
      ref="selectableTable"
      show-empty
      :busy="loading"
      class="table-centered table-nowrap table-hover table-main-border order-menu"
      selectable
      select-mode="single"
      @row-clicked="viewPageDetails"
    >
      <template #empty>
          <p class="text-center">{{ trans.get('__JSON__.No Order Found') }}</p>
      </template>
      <template #table-busy>
        <div class="text-center text-danger my-2">
          <b-spinner class="align-middle"></b-spinner>
          <strong>{{trans.get('__JSON__.Loading...')}}</strong>
        </div>
      </template>
      <template #cell(order_id)="data">
        <span class="font-weight-bold">{{ data.value }}</span>
        <span class="badge badge-pill badge-soft-primary font-size-12" v-if="data.item.delivery_pickup_types == 'Delivery'">
          {{trans.get('__JSON__.'+data.item.delivery_pickup_types)}}
        </span>
        <span class="badge badge-pill badge-soft-danger font-size-12" v-if="data.item.delivery_pickup_types == 'Takeaway'">
          {{trans.get('__JSON__.'+data.item.delivery_pickup_types)}}
        </span>
        <span class="badge badge-pill badge-soft-danger font-size-12" v-if="data.item.delivery_pickup_types == 'Pickup'">
          {{trans.get('__JSON__.'+data.item.delivery_pickup_types)}}
        </span>
        <br v-if="data.item.future_delivery_date != '0000-00-00 00:00:00' && data.item.future_delivery_date != null || data.item.access_name">
        <span class="badge badge-pill badge-success font-size-12" v-if="data.item.future_delivery_date != '0000-00-00 00:00:00' && data.item.future_delivery_date != null">
          Scheduled
        </span>
        <b-badge v-if="data.item.access_name" pill class="font-size-12 badge-soft-secondary mt-1"><i class="bx bx-phone-call"></i> {{ data.item.access_name }}</b-badge>
      </template>
      <template #cell(vendor_name)="data">
        <!-- {{ data.item.restaurant && data.item.restaurant.name || data.item.id}} -->
        <span class="font-weight-bold">{{ data.value }}</span>
      </template>
      <template #cell(customer_name)="data">
        <!-- {{ data.item.user && (data.item.user.user_name +" "+ data.item.user.last_name) || data.item.id}} -->
        {{ data.value}}
      </template>
      <template #cell(created_date)="data">
        <!-- {{ moment(data.value).format('DD-MM-YYYY hh:mm A') }} <span v-b-tooltip.hover.v-light :title="data.value" class="font-size-15"><i class="bx bx-info-circle"></i></span> -->
        {{ moment(data.value).fromNow() }} <span v-b-tooltip.hover.v-light :title="data.value" class="font-size-15"><i class="bx bx-info-circle"></i></span>
      </template>
      <template #cell(total_amount)="data">
       <div style="white-space: nowrap;">
        <span v-html="currency"></span> {{(data.value || 0).toFixed(decimal) }}
        </div>
      </template>
      <!-- <template #cell(delivery_pickup_types)="data">
        <span class="badge badge-pill badge-soft-primary font-size-12" v-if="data.value == 'Delivery'">
          {{trans.get('__JSON__.'+data.value)}}
        </span>
        <span class="badge badge-pill badge-soft-danger font-size-12" v-if="data.value == 'Takeaway'">
          {{trans.get('__JSON__.'+data.value)}}
        </span>
        <span class="badge badge-pill badge-soft-danger font-size-12" v-if="data.value == 'Pickup'">
          {{trans.get('__JSON__.'+data.value)}}
        </span>
      </template> -->
      <template #cell(payment_method)="data">
        <span class="badge badge-pill font-size-12" :class="{'badge-soft-success': (data.value == 'Cash On Delivery'),'badge-soft-warning':(data.value != 'Cash On Delivery')}"
          v-if="data.item.order_status !== 'PaymentPending' && data.item.order_status !== 'PaymentFailure' && data.item.order_status !== 'AwaitForPayment'"
        >
          {{data.value == 'Cash On Delivery'?'COD':data.value}}
        </span>
        <span v-else class="badge badge-pill font-size-12"  :class="{'badge-soft-warning': (data.item.order_status == 'PaymentPending'),'badge-soft-danger':(data.item.order_status == 'PaymentFailure'),'badge-soft-info':(data.item.order_status == 'AwaitForPayment')}">
          {{data.item.order_status == 'PaymentPending' ? trans.get('__JSON__.Pending'): (data.item.order_status == 'PaymentFailure' ? trans.get('__JSON__.Failed') : trans.get('__JSON__.Awaiting'))}}
        </span>
      </template>
      <template v-for="(col,index) in extraColumns" v-slot:[`cell(${col.key})`]="data" >
        <span v-if="col.key == 'future_delivery_date'" :key="index">
          <span>{{ data.value }}</span>
          <span v-b-tooltip.hover.v-light :title="moment(data.value).fromNow()" class="font-size-15">
              <i class="bx bx-info-circle"></i>
          </span>
        </span>
        <span v-else-if="col.key.indexOf('date') !== -1" :key="index">
          <span>{{ moment(data.value).fromNow() }}</span>
          <span v-b-tooltip.hover.v-light :title="data.value" class="font-size-15">
              <i class="bx bx-info-circle"></i>
          </span>
        </span>
        <div v-else-if="col.key == 'assign' && !$auth.partner_login" :key="index">
          <!-- <OrderAssign :order="data.item" v-if="data.item.delivery_pickup_types == 'Delivery'" @actionChanged="$emit('refreshData')"/> -->
          <OrderAssign :order="data.item" v-if="data.item.delivery_pickup_types == 'Delivery' && data.item.is_dunzo_driver === '0' && data.item.is_load_sharing_driver === '0'" @actionChanged="$emit('refreshData')" :adminDriverServicesList="driverServicesList"/>
          <!-- <OrderAssign :order="data.item" v-else-if="data.item.delivery_pickup_types == 'Delivery' && driverServicesList.length > 1 && driverServicesList.some(function(o){return o['service_name'] === config.systemdrivername;})" @actionChanged="$emit('refreshData')" :adminDriverServicesList="driverServicesList" /> -->
          <span v-else>-</span>
        </div>
        <div v-else-if="col.key == 'track' && !$auth.partner_login" :key="index">
          <template v-if="data.item.is_dunzo_driver == '0' && data.item.is_load_sharing_driver == '0'">
            <div class="text-center" v-if="data.item.delivery_pickup_types == 'Delivery'">
              <b-button v-if=" $auth.hasPermission(config.permissions.order_write)" variant="primary" size="sm" @click="trackOrder(data.item)" >{{trans.get('__JSON__.Track')}}</b-button>
              <i v-else v-b-tooltip="'Need Permission'" class="mdi mdi-information h4 text-danger"></i>
            </div>
            <span v-else>-</span>
          </template>
          <template v-else-if="data.item.is_dunzo_driver == '1'">
            <div class="text-center" v-if="data.item.delivery_pickup_types == 'Delivery' && checkDunzoTrackAvailability(data.item)">
              <b-button v-if=" $auth.hasPermission(config.permissions.order_write)" variant="primary" size="sm" @click="trackDunzoOrder(data.item)" >{{trans.get('__JSON__.Track')}}</b-button>
              <i v-else v-b-tooltip="'Need Permission'" class="mdi mdi-information h4 text-danger"></i>
            </div>
            <span v-else>-</span>
          </template>
        </div>
        <span v-else-if="col.key == 'driver'">
          <template v-if="data.item.is_dunzo_driver === '0' && data.item.is_load_sharing_driver === '0'">
            {{data.value}}
          </template>
          <template v-else-if="data.item.is_load_sharing_driver === '1' && data.item.load_share_driver">
            {{ data.item.load_share_driver.runner ? data.item.load_share_driver.runner.name : '-' }}
          </template>
          <template v-else-if="data.item.is_dunzo_driver === '1' && data.item.dunzo_driver">
            {{ data.item.dunzo_driver.runner ? data.item.dunzo_driver.runner.name : '-' }}
          </template>
        </span>

      </template>
      <template #cell(action)="data">
        <OrderAction :order="data.item" @actionChanged="$emit('refreshData')" />
        <!-- <b-button variant="primary" class="btn-sm btn-rounded" @click="viewDetails(data.item.base_id)">{{trans.get('__JSON__.View')}}</b-button> -->
      </template>
    </b-table>
    </div>
  </div>
  <OrderTrack v-if="showTrackModel" :order="order" @hidden="showTrackModel = false" />
  <OrderShow v-if="showModal"  :order-id="orderId" @hidden="showModal = false" @actionChanged="$emit('refreshData')" />
  <DunzoOrderTrack v-if="showDunzoTrackModel" :order="order" @hidden="showDunzoTrackModel = false" />
  <!-- View Detail Main End -->
</div>
</template>
<style>
.fa-calendar:before{
  content: unset !important;
}
</style>
